
/* castle.c    Metaprat                                   */

/* This is the castle used to autoload the keys, insurance policies.. */
/* Its invisible, and uses call_outs to prevent errors stopping the   */
/* two important items from not autoloading.                          */

#define DEST "/room/storage"

object storage;
object lockers;
object estate;


reset(arg) {
   /* preload all the autoloading objects that I use. */
   /* If this is not done, the first players into the */
   /* game will lose keys, policies, etc.             */
   call_out("preload_locker", 0);  /* with 0 delay, the routines should */
   call_out("preload_houses", 0);  /* be called after reset() finishes. */

   /* make sure the storage room is loaded into the game */
   if (!storage) {
      DEST->XXXXXXXX();
      storage = find_object(DEST);
   }
   move_object(this_object(),storage);
}



preload_locker() {
   remove_call_out("preload_locker");

   "/players/metaprat/misc_objs/insurancequote"->XXXXXXX();

   /* check if lockers already exist.  If not, load them, and move them */
   "/players/metaprat/misc_objs/lockers"->XXXXXXX();
   if (!lockers) {
      lockers = find_object("/players/metaprat/misc_objs/lockers");
   }
   if (!present("lockers", storage)) {
      move_object(lockers, storage);
   }
}



preload_houses() {
   remove_call_out("preload_houses");

   "/players/metaprat/houses/house_key"->XXXXXXX();
   "/players/metaprat/houses/house_invite"->XXXXXXX();

   /* check if estate agent already exists.  If not, load it, and move. */
   "/players/metaprat/houses/estate_agent"->XXXXXXXX();
   if (!estate) {
      estate = find_object("/players/metaprat/houses/estate_agent");
   }
   if (!present("agent", storage)) {
      move_object(estate, storage);
   }
}



id(str) {
   return (str == "metaprat_castle") ||
          (str == "metaprat castle") ||
          (str == "castle");
}



short() {
    return 0;   /* invisible */
}


long() {
   write("Eh? This is supposed to be invisible!\n");
   write("Anyway, it returns an ID of metaprat_castle.\n");
}


