
 /* house_NEW_OWNER.c   V2.1      Metaprat       6th April 1992  */

#include "house_defines.h"



/* DYNAMIC variables (restored and saved) */
string rooms_desc;
string rooms_short;
string rooms_items;
string furnishings;
int    rooms_x;
int    rooms_y;
int    rooms_z;
string exits_special;
string exits_wizard;
int    exits_north;
int    exits_ne;
int    exits_east;
int    exits_se;
int    exits_up;



short() {
   return "A NEW_OWNER house creator.  Use this to create the first house";
}


id(str) {
   return (str == "house creator") || (str == "creator");
}


init() {
   if (IAMWIZ) {
      add_action("make_NEW_OWNER", "make_new_owner");
   }
}


make_NEW_OWNER() {
   rooms_desc    = allocate(3);
   rooms_short   = allocate(3);
   rooms_items   = allocate(3);
   furnishings   = allocate(3);
   rooms_x       = allocate(3);
   rooms_y       = allocate(3);
   rooms_z       = allocate(3);
   exits_north   = allocate(3);
   exits_east    = allocate(3);
   exits_ne      = allocate(3);
   exits_se      = allocate(3);
   exits_special = allocate(3);
   exits_wizard  = allocate(3);
   exits_up      = allocate(3);

   rooms_desc    [0] =
"You are in the main hallway, leading from the entrance, to the kitchen.\n" +
"Buckets of paint, and rolls of wallpaper, suggest that it would be nice\n" +
"to decorate this newly-built house.  There is an instruction manual in\n" +
"the corner.\n";
   rooms_short   [0] = "Main hallway of a new house";
   rooms_items   [0] =
({ "entrance",          "It leads to the church",
   "paint",             "A row of large 5 litre tins of creamy white paint",
   "wallpaper",         "Stacks of white wallpaper make you want to decorate",
   "manual",            "Type 'help house'",
   "instruction manual","Type 'help house'" });
   furnishings   [0] = ({ });
   rooms_x       [0] = 0;
   rooms_y       [0] = 0;
   rooms_z       [0] = 0;
   exits_north   [0] = 0;
   exits_east    [0] = 0;
   exits_ne      [0] = 0;
   exits_se      [0] = 10;
   exits_special [0] = ({ "church" });
   exits_wizard  [0] = ({ "castle" });
   exits_up      [0] = 0;
   rooms_desc    [1] =
"This appears to be the new kitchen, with a large sink, an oven, a drinks\n" +
"cabinet, and some other household equipment, supplied gratis by the\n" +
"builders.  In fact, they're so generous, there seems to be something\n" +
"in the cupboard, in case you're hungry.\n";
   rooms_short   [1] = "Kitchen of a new house";
   rooms_items   [1] =
({ "sink",      "A sink full of unwashed dishes",
   "oven",      "A large oven, ready to cook food in",
   "equipment", "You know, electricity sockets, taps, that sort of thing" });
   furnishings   [1] = ({ "kitchen" });
   rooms_x       [1] = 0;
   rooms_y       [1] = 1;
   rooms_z       [1] = 0;
   exits_north   [1] = 1;
   exits_east    [1] = 10;
   exits_ne      [1] = 0;
   exits_se      [1] = 0;
   exits_special [1] = ({ });
   exits_wizard  [1] = ({ });
   exits_up      [1] = 0;
   rooms_desc    [2] =
"A large bed is the centerpiece of this room.  It is a new pine four-" +
"poster,\nwith matt black curtains dangling from the upper corners.\n";
   rooms_short   [2] = "Bedroom of a new house";
   rooms_items   [2] =
({ "bed",      "Its a bed.  A sort of soft raised flat surface",
   "curtains", "The curtains seem to be aesthetic, rather than functional" });
   furnishings   [2] = ({ });
   rooms_x       [2] = 1;
   rooms_y       [2] = 1;
   rooms_z       [2] = 0;
   exits_north   [2] = 0;
   exits_east    [2] = 0;
   exits_ne      [2] = 0;
   exits_se      [2] = 0;
   exits_special [2] = ({ });
   exits_wizard  [2] = ({ });
   exits_up      [2] = 0;

   log_file(LOGFILE, "House_NEW_OWNER: creating new NEW_OWNER file.\n");
   save_object(HOUSES_DIR + "NEW_OWNER");
   write(HOUSES_DIR + "NEW_OWNER.o created.  Now destruct this item.\n");
   return 1;
}

