
 /* House_help.c        Metaprat       16th April 1992   */


#include "house_defines.h"


help(str) {
   if (!str) {
      return 0;
   }
   if (str == "house") {
write("Welcome to your new Metaprat Industries house.  These houses\n");
write("have been specially designed for the comfort and convenience\n");
write("of you, the consumer.  The owner may decorate as he or she\n");
write("wishes, and the new design will remain perfect even if the\n");
write("mud itself crashes or shuts down.  Furthermore, he or she has\n");
write("an unprecidented degree of access control; friends may be\n");
write("invited, and even banished if they don't behave themselves.\n");
write("For summaries of each of these points, please enter:\n");
write("        help map              help decorate\n");
write("        help build            help furnish\n");
write("        help doors            help rooms\n");
write("        help invite           help expel\n");
write("        help destroy          help items\n");
write("        help kitchen\n");
      if (IAMWIZ) {
         write("\"help wizard house\" text follows.\n");
         help("wizard house");
      }
      return 1;
   }
   if (str == "map") {
write("Is this house so large that you need a map to explore it?\n");
write("Well, worry not!  ACME DIY provides cheap, biodegradable maps\n");
write("to anyone who requests one with the 'map' command.  The paper\n");
write("is designed to have a minimum impact on the environment, by\n");
write("degrading into harmless dust after a few minutes.\n");
   if (IAMWIZ) {
      write("Wizards may use the command 'draw_house_of <person>'.\n");
   }
write("Cost: " + MAPCOST + ".\n");
write("See also: house.\n");
      return 1;
   }
   if (str == "decorate") {
write("With the aid of ACME DIY, the appearence and even role of any\n");
write("room may be totally changed, with a minimum of effort.\n");
write("Simply by using the 'decorate' command, the lucky customer\n");
write("may permanently modify the description of a room.  Using\n");
write("the elegant and simple interface made famous by the bulletin\n");
write("boards, the customer can specify the new design, see what it\n");
write("would look like, and is then given the option to go ahead\n");
write("with the redecoration, or not.\n");
write("Cost: " + DECORCOST + " coins.\n");
write("Also: house, build, destroy, furnish, kitchen, doors, rooms, items.\n");
      return 1;
   }
   if (str == "build") {
write("Extensions for you wonderful new house allow you to expand\n");
write("to your heart's desire*.  You can build new rooms, and new\n");
write("doors, simply by saying   'build room east'.  If you have\n");
write("built a room you don't want anymore, then it may be\n");
write("destroyed if you wish.\n");
write("*- if you desire " + MAXNUMROOMS + " rooms or less, that is :-)\n");
write("Cost: " + ROOMCOST + " gp for a new room, and " + DOORCOST);
write(" gp for a door.\n");
write("Also: house, decorate, destroy, furnish, doors, rooms, items.\n");
      return 1;
   }
   if (str == "destroy") {
write("If you want to get rid of an exit, or a room that is surplus\n");
write("to your requirements, you may 'destroy room'.  To get rid of\n");
write("a room, you must be in it at the time, and also must have\n");
write("already destroyed all the exits to the room.\n");
write("Destroying an exit is equally easy, simply 'destroy exit'\n");
write("or 'destroy door north', and it will be removed rapidly.\n");
write("However; a word of warning.  If you isolate rooms, it may\n");
write("be expensive to build rooms and exits to reach them again.\n");
write("Cost: Free for a room, and " + DOORCOST + " coins to destroy\n");
write("each exit.\n");
write("Also: house, decorate, build, furnish, doors, rooms, items.\n");
      return 1;
   }
   if (str == "furnish") {
write("Allows the owner to set one or more special features in a\n");
write("room.  At the moment, only one special feature exists.\n");
write("Furnish types:   'kitchen'  ('cook' food & 'pour' drinks)\n");
write("For information about a particular furnishing, help <thing>\n");
write("To furnish a room, 'furnish [type]'.\n");
write("Cost: " + FURNISHCOST + " coins to add a furnish option\n");
write("to a room.\n");
write("Also: house, decorate, build, destroy, doors, rooms, items.\n");
      return 1;
   }
   if (str == "kitchen") {
write("This is one of the furnishing options.  Essentially, it\n");
write("gives you a wide selection of food and drink to buy.  To see\n");
write("the list of items, 'look at drinks cabinet'  (to see drinks)\n");
write("or                 'look at ingredients'   (to see food).\n");
write("Also the aliases 'cupboard' and 'food' exist for the food,\n");
write("and 'drinks' and 'cabinet' for the drinks.  It looks good if\n");
write("you mention the name in the rooms description.\n");
write("To actually get an item, 'pour <drink>' or 'cook <food>'.\n");
write("Cost: Varies according to the item.  Stated in the list.\n");
write("See also: furnish.\n");
      return 1;
   }
   if (str == "items") {
write("This command allows the owner to define examinable items in\n");
write("the room.  Up to " + MAXITEMNUM + " items may be defined in\n");
write("each room, with one line of text as the description.\n");
write("Cost: " + ITEMCOST + " coins each time the items list is\n");
write("updated by the owner.\n");
write("Also: house, decorate, build, destroy, furnish, doors, rooms.\n");
      return 1;
   }
   if ((str == "doors") || (str == "exits")) {
write("ACME DIY supply the following types of doors:\n");
write("   Simple exits,\n");
write("   Doors that may open and close,\n");
write("   Doors that may be locked, by the owner of the house,\n");
write("   Magic Portals, that only the owner of the house may use,\n");
write("   Hidden exits, not shown on map, or obvious exits line.\n");
write("   Exits to the church, guild, shop, pub, and post office.\n");
write("To get a new door, simply:   'build door north'.\n");
write("Doors may be build in most directions, including upwards.\n");
write("Cost: " + DOORCOST + " coins to get a new exit.\n");
write("See also: house, decorate, build, furnish, rooms.\n");
      return 1;
   }
   if (str == "rooms") {
write("ACME DIY has connections with many reputable builders, who\n");
write("will be glad to add an extension to your house.  Not only\n");
write("are you supplied with a wonderful new room in your house,\n");
write("you are sold a wonderful door to it!\n");
write("To have the room build, simply:   'build room north', and\n");
write("the new room and the connecting door will be put into place\n");
write("immediately, by the 24-hour speedy-builder (Ltd) firm.\n");
write("Due to the local housing regulations, you can have up to " +
            MAXNUMROOMS + "\n");
write("rooms, but no more.  Rooms may be demolished if you wish, by\n");
write("using the 'destroy' command.\n");
write("Rooms may be built up and down, as well as the eight cardinal\n");
write("directions (north, south.. northeast, northwest.. ).\n");
write("Cost: " + ROOMCOST + " gp to build a new room, with another\n");
write(DOORCOST + " gp for the exit leading to it.\n");
write("See also: house, decorate, build, furnish, doors.\n");
      return 1;
   }
   if (str == "invite") {
write("Let your friends admire your new house; invite them in for a\n");
write("house warming party!  Decorate the place with balloons and\n");
write("tinsel, then get down and _rock_!  Yes, thats right, invite\n");
write("will send your friends a rapid mail invitation, all they\n");
write("to do is go the the church, or to a house, and accept it!\n");
write("In no time at all, they'll be crowding around in your house\n");
write("gasping at the amazing decor!\n");
write("'invite <person>' to give then a normal invitation, and\n");
write("'invite <person> permanent' to give them a permanent invitation.\n");
write("Cost: " + INVITECOST + " coins for a once-only invitation,\n");
write("Cost: " + INVITEPERMCOST + " coins for a permanent invitation.\n");
write("See also: house, expel.\n");
      return 1;
   }
   if ((str == "banish") || (str == "expel")) {
write("When things get too rough, as they always do, the customer\n");
write("can always rely on the ability to expel the trouble makers\n");
write("from the new house.  Simply 'expel <person>'!  Yes, thats\n");
write("right, they'll get booted into the church with the proles\n");
write("where they belong, leaving the house nice and peaceful.\n");
write("Naturally, if an invitation has been issued to someone, the\n");
write("expulsion will also cancel their invitation.\n");
write("Cost: Free.\n");
write("See also: house, invite.\n");
      return 1;
   }

   /* Below this point are all wizard help files. */
   if (!IAMWIZ) {
      return 0;
   }
   if (str == "wizard house") {
write("Wizards can use the following commands:\n");
write("  generate_lpc  -- writes LPC code into /open for the room.\n");
write("  room_stats    -- shows statistics for the current room.\n");
write("  agent_stats   -- shows revenue statistics since reboot.\n");
write("  master_stats  -- shows statistics of all houses.\n");
write("Functions that may be useful:\n");
write("  in \"/players/metaprat/houses/master_house\",\n");
write("     query_house(person's name); returns ptr -> house.\n");
write("  in house object,\n");
write("     query_room(index); returns ptr to room objects.\n");
write("     self_destruct(); destructs every room.\n");
write("See also:  generate_lpc, query_house,\n");
write("  query_room, self_destruct, restore_stats, set_owner,\n");
write("  query_owner, find_room, get_room_index,\n");
write("  query_room_position.\n");
      return 1;
   }
   if (str == "query_house") {
write("Defined in: " + MASTERHOUSE + ".\n");
write("Parameter: owner's name.\n");
write("Returns: object ptr to current house object, or zero.\n");
write("Usually houses will not have been created, unless the owner has\n");
write("entered it recently.  If the house is currently active, this\n");
write("routine will return the object pointer to it.  For example, a\n");
write("code fragment to exit to a house from your workroom would be:\n");
write("move(str) {\n");
write("   object house;\n");
write("   if (query_verb() == \"entrance\") {\n");
write("      house = \"" + MASTERHOUSE + "\"->query_house(\"metaprat\");\n");
write("      if (!house) {\n");
write("         house = clone_object(\"" + HOUSE + "\");\n");
write("         house->set_owner(\"metaprat\");\n");
write("         house->restore_stats(\"metaprat\");\n");
write("      }\n");
write("      this_player()->\n");
write("         move_player(query_verb() + \"#\" + file_name(house));\n");
write("      return 1;\n");
write("   }\n");
write("   return ::move(str);\n");
write("}\n");
write("Also: master_stats, query_house_exists, set_owner, restore_stats.\n");
      return 1;
   }
   if (str == "query_house_exists") {
write("Defined in: " + MASTERHOUSE + ".\n");
write("Parameter: owner's name.\n");
write("Returns: true or false.\n");
write("Searches the master house database to find out if a house has\n");
write("ever been registered for a given owner.\n");
write("Also: master_stats, query_house, set_owner, restore_stats.\n");
      return 1;
   }
   if (str == "generate_lpc") {
write("Parameters: full file path.\n");
write("This generates code that approximately simulates the current house\n");
write("room, into the filename specified.  Remember to create any subdirs\n");
write("mentioned in the file path, and that you can only generate files\n");
write("into /open/.. and /players/yourname/... (or subdirectories within\n");
write("those areas).  The houses make some assumptions about the filename,\n");
write("the default path is:\n");
write("    generate_lpc /players/yourname/rooms/house_XX, where XX is\n");
write("the index number of the current room (see room_stats).  If you\n");
write("give the 'house_' bit a different name, change the PREFIX\n");
write("definition in the rooms.\n");
write("See also: wizard house, room_stats.\n");
      return 1;
   }
   if ((str == "room_stats") || (str == "agent_stats") ||
       (str == "master_stats")) {
write("Parameters: None.\n");
write("These commands are available in your own house.  Once you have\n");
write("typed one, you are given a 'house stats' object, which is portable.\n");
write("\troom_stats  \t- stats of current house room.\n");
write("\tagent_stats \t- stats of revenue since last reboot.\n");
write("\tmaster_stats\t- stats from the master houses object.\n");
write("See also:  wizard house.\n");
      return 1;
   }
   if (str == "self_destruct") {
write("Defined in: main house (room 0).\n");
write("Parameters: none.\n");
write("This function will destruct each room in turn, moving out all\n");
write("objects inside them to the church.  The data structures in\n");
write("the save file will be intact, so it is used mainly for\n");
write("updating the house version, or saving memory.\n");
write("At every reset, the houses are checked.  If they are empty,\n");
write("*and* the owner is logged out, then they self_destruct to\n");
write("save memory.\n");
write("See also: wizard house\n");
      return 1;
   }
   if (str == "restore_stats") {
write("Defined in: main house (room 0).\n");
write("Parameters: string owner_name.\n");
write("This function restores the house data structures from the\n");
write("owner_name save file.  Note that the rooms will NOT be\n");
write("updated, so it should be followed by a call to self_destruct.\n");
write("If you want to record the data structures into the real\n");
write("owner's file, some activity that does this must be performed.\n");
write("(eg, changing a door type, or redecorating).\n");
write("This effectively allows us to copy one save file onto\n");
write("another.  The only time when this is useful is when we want\n");
write("to change a player's name, or give a copy of his house to\n");
write("someone.  A special owner_name is NEW_OWNER.\n");
write("See also: wizard house\n");
      return 1;
   }
   if (str == "set_owner") {
write("Defined in: main house (room 0).\n");
write("Parameters: string owner_name.\n");
write("Allows us to change the owner name in the house itself.  This\n");
write("means that any changes the original owner makes will be\n");
write("recorded under the new name.  Be very careful using this.\n");
write("See also: wizard house\n");
      return 1;
   }
   if (str == "query_owner") {
write("Defined in: main house (room 0).\n");
write("Parameters: none.\n");
write("Guess! .. the owner name is the player's query_real_name.\n");
write("See also: wizard house\n");
      return 1;
   }
   if (str == "find_room") {
write("Defined in: main house (room 0).\n");
write("Parameters: int loc_x, int loc_y, int loc_z.\n");
write("Do not all this unless you are sure that a room exists at\n");
write("that location (eg, get_room_index() returns >= 0).\n");
write("It will return the object number of the room.  If the room\n");
write("has not been initialised, it will initialise it first.\n");
write("See also: wizard house\n");
      return 1;
   }
   if (str == "get_room_index") {
write("Defined in: main house (room 0).\n");
write("Parameters: int loc_x, int loc_y, int loc_z.\n");
write("This will return the rooms index number, which is from 0 to\n");
write("" + MAXNUMROOMS + ".  If no room at that location is found, then " +
      "returns -1.\n");
write("See also: wizard house\n");
      return 1;
   }
   if (str == "query_room_position") {
write("Defined in: main house (room 0).\n");
write("Parameters: int indx  (0 to MAXNUMROOMS).\n");
write("It will return an array of int loc_x, int loc_y, int loc_z.\n");
write("The X positions are: west is -1, east is + 1.\n");
write("The Y positions are: north is -1, south is + 1.\n");
write("The Z positions are: down is -1, up is + 1.\n");
write("This is relative to the main room, so that a room which\n");
write("is S, W, W of the main room is ({ -2, 1 )}.\n");
write("If there is no room at that index number, then it returns\n");
write("a null string, and can therefore be used to locate unused\n");
write("spaces in the data arrays.\n");
write("See also: wizard house\n");
      return 1;
   }
   return 0;   /* probably just a normal help command */
}
