
 /* house_sustenance.c       Metaprat       11th Aug 1992  */

 /* For customisation details, look in house_defines.h     */

 /* This object is used as a sort of pub, for player's     */
 /* kitchens.                                              */

#include "house_defines.h"

string menu_array;

reset(arg) {
   if (arg) {
      return;
   }
   /* Use the definitions in the house_defines.h to modify the  */
   /* overall cost, strength and heal value of the food and     */
   /* drink.  The local mud policy on coffee (sober-upper), and */
   /* full heals should be taken into account also.             */
   /* Menu array format.                                        */
   /* (Note:.. heal should usually be == str).                  */
   /* ({ "id1", "id2", "id3", value, str, heal, filename,       */
   /*    short, long, [msg to consumer], [container]         }) */

   menu_array = ({ });

   if (ALLOW_DRINK) {
      menu_array = menu_array + ({
({ "light beer",  "light",  "beer",
   DRINK_COST_TUNE(DRINK_COST_FORMULA(3)),   3,   3,  DRINK_FILE,
   "A bottle of light beer",
   "A bottle of light, watery beer.\n",
   "You drink it down quickly.\n",
   "bottle" }),
({ "dark beer",  "dark",  "beer",
   DRINK_COST_TUNE(DRINK_COST_FORMULA(5)),   5,   5,  DRINK_FILE,
   "A bottle of dark beer",
   "A bottle of rich, dark beer.\n",
   "You drink it down quickly.\n",
   "bottle" }) });

      if (DRINK_ALLOW_COFFEE) {
         /* Must have the house_drink object to work, since alco_drink */
         /* and soft_drink want intox and heal to be the same.  Note   */
         /* that /obj/drink will probably work, but hasn't been tested */
         /* with this.                                                 */
         menu_array = menu_array + ({
({ "cup of darjeeling tea", "darjeeling tea", "tea",
   DRINK_COST_TUNE(DRINK_COST_FORMULA(6)),  -6,   0,  DRINK_FILE,
   "A small cup of Darjeeling tea",
   "A steaming cup of white Darjeeling tea.\n",
   "You drink the refreshing cup of Darjeeling.\n",
   "cup" }),
({ "can of coca-cola", "cocacola", "coca-cola",
   DRINK_COST_TUNE(DRINK_COST_FORMULA(8)),  -7,   2,  DRINK_FILE,
   "A cold can of Coca-Cola",
   "An icy can covered in the familar red logo of Coca-Cola.\n",
   "You open the can, and drink the Real Thing.\n",
   "can" }),
({ "mug of black coffee", "black coffee", "coffee",
  DRINK_COST_TUNE(DRINK_COST_FORMULA(9)),  -8,   3,  DRINK_FILE,
  "A large mug of coffee",
  "A steaming hot mug of black coffee.\n",
  "You feel the coffee rush down your throat, sobering you up.\n",
  "mug" })
});
      }

      menu_array = menu_array + ({
({ "newcastle brown ale",  "brown ale",   "ale",
   DRINK_COST_TUNE(DRINK_COST_FORMULA(10)), 10,  10,  DRINK_FILE,
   "A newcastle brown ale",
   "This is the very famous Newcastle Brown.\n",
   "You drink the cool, refreshing newcy brown.\n",
   "bottle" }),
({ "red wine",   "wine",    "wine",
   DRINK_COST_TUNE(DRINK_COST_FORMULA(15)), 15,  15,  DRINK_FILE,
   "A bottle of red wine",
   "A bottle of a deep red wine.\n",
   "You drink the entire bottle of red wine.\n",
   "bottle" }),
({ "sweet sherry",   "sherry",     "sherry",
   DRINK_COST_TUNE(DRINK_COST_FORMULA(20)), 20,  20,  DRINK_FILE,
   "A bottle of sherry",
   "A bottle of a strong, sweet sherry.\n",
   "You gasp, as you quaff the sherry.\n",
   "bottle" }),
({ "sloe gin",     "gin",    "sloe",
   DRINK_COST_TUNE(DRINK_COST_FORMULA(30)), 30,  30,  DRINK_FILE,
   "A bottle of sloe gin",
   "A bottle of a strong sloe gin.\n",
   "Your eyes bug out, as you drink the sloe gin.\n",
   "bottle" }),
({ "aged malt whisky",     "malt whisky",    "whisky",
   DRINK_COST_TUNE(DRINK_COST_FORMULA(37)), 37,  37,  DRINK_FILE,
   "A bottle of ten year old malt whisky",
   "A bottle of a ten year old malt whisky.\n",
   "You savour the aroma and taste of the malt.\n",
   "bottle" }),
({ "distilled quince brandy", "brandy", "quince",
   DRINK_COST_TUNE(DRINK_COST_FORMULA(44)), 44,  44,  DRINK_FILE,
   "A bottle of distilled quince brandy",
   "A bottle of a very potent distilled quince brandy.\n",
   "You shake, as you drink the quince brandy.\n",
   "bottle" }) });

      if (DRINK_ALLOW_HEAL) {
         /* must have the house_drink.c object to work  */
         /* price is based around average heal of (say) */
         /* 160, with a lot added on to account for the */
         /* fact you don't get very drunk from it.      */
         menu_array = menu_array + ({
({ "potion of healing",   "potion",   "heal",
   DRINK_COST_TUNE(DRINK_COST_FORMULA(230)), 10, 200,  DRINK_FILE,
   "A potion of healing",
   "A small bottle containing a glittering fluid.. a heal potion!\n",
   "As you drink the fluid, you feel your body burning.\n",
   "vial" }) });
      }
   }

   if (ALLOW_FOOD) {
      menu_array = menu_array + ({
({ "ripe apple",   "apple",    "red apple",
   FOOD_COST_TUNE(FOOD_COST_FORMULA(5)), 5, 5, FOOD_FILE,
   "A red, ripe apple",
   "A nice apple, ripe and ready to eat.\n",
   "You eat the delicious crunchy apple.\n" }),
({ "spicy apple pie",  "apple pie",    "pie",
   FOOD_COST_TUNE(FOOD_COST_FORMULA(12)), 12, 12, FOOD_FILE,
   "A delicious apple pie",
   "An apple pie, freshly baked, and steaming gently.\n",
   "You wolf down the pie, and feel it filling your stomach.\n" }),
({ "creamy turnip soup",  "turnip soup",    "soup",
   FOOD_COST_TUNE(FOOD_COST_FORMULA(16)), 16, 16, FOOD_FILE,
   "A bowl of thick and creamy turnip soup",
   "A bowl full to the brim with thick and creamy  turnip soup.\n",
   "You savour the delicious, filling soup.\n" }),
({ "beef stew",  "beef",    "stew",
   FOOD_COST_TUNE(FOOD_COST_FORMULA(23)), 23, 23, FOOD_FILE,
   "A plate of freshly cooked beef stew",
   "A plate of delicious smelling beef stew.\n",
   "You eat your beef meal, and feel well satisfied.\n" }),
({ "venison steak",  "venison",    "steak",
   FOOD_COST_TUNE(FOOD_COST_FORMULA(35)), 35, 35, FOOD_FILE,
   "A delicious meal, based around a huge venison steak",
   "A three course meal, the centerpiece is a huge venison steak.\n",
   "You sit down to your feast, and eat until you can eat no more.\n"
})
      });
   }
}


list_items(sust_type) {
   string menu;
   int    counter;

   if (!menu_array || !sizeof(menu_array)) {
      return ;
   }
   menu = "";
   if (((!sust_type) || (sust_type == "drink")) && (ALLOW_DRINK)) {
      menu = menu + "In the drinks cabinet, you see:  ('pour <item>')\n";
      for (counter = 0; counter < sizeof(menu_array); counter ++) {
         if (menu_array[counter][6] == DRINK_FILE) {
            menu = menu + "\t" + menu_array[counter][3] +           /* cost  */
                   " \tgold, \t" + menu_array[counter][7] + ".\n";  /* short */
         }
      }
   }
   if (((!sust_type) || (sust_type == "food")) && (ALLOW_FOOD)) {
      menu = menu + "You have ingredients to cook:    ('cook <item>')\n";
      for (counter = 0; counter < sizeof(menu_array); counter ++) {
         if (menu_array[counter][6] != DRINK_FILE) {
            menu = menu + "\t" + menu_array[counter][3] +           /* cost  */
                   " \tgold, \t" + menu_array[counter][7] + ".\n";  /* short */
         }
      }
   }
   write(menu);
}


short() {
   return "house sustenance object";
}


id(str) {
   return str == "house sustenance";
}


order(str) {
   int    counter;
   int    which_item;
   object drink;

   if (!str) {
      write("What to you want to buy?\n");
      return 1;
   }

   which_item = -1;
   for (counter = 0; counter < sizeof(menu_array); counter ++) {
      if ((str == menu_array[counter][0]) ||    /* name     */
          (str == menu_array[counter][1]) ||    /* alt_name */
          (str == menu_array[counter][2])) {    /* alias    */
         which_item = counter;
         break;
      }
   }

   if (which_item < 0) {
      write("Sorry, I don't see that here.\n");
      return 1;
   }

   if (!MONEY->has_money( menu_array[which_item][3] )) {  /* cost */
       return 1;
   }

   drink = make_sustenance( menu_array[which_item] );

   /* check if the player can carry it.  If not, then put it in */
   /* his/her environment.                                      */
   if (!this_player()->add_weight(drink->query_weight())) {
      write("You are carrying too much, and put the " +
            menu_array[which_item][0] + " onto " +
            "the floor next to you.\n");
      move_object(drink, environment(this_player()));
   }
   else {
      move_object(drink, this_player());
   }
   MONEY->charge_money(menu_array[which_item][3],"drink");
   if (menu_array[which_item][6] == DRINK_FILE) {
      write("You take a " + menu_array[which_item][0] +
            " from the drinks cabinet.\n");
      tell_room(environment(this_player()),
                MYCNAME + " takes " +
                menu_array[which_item][0] + " from the drinks cabinet.\n");
   }
   else {
      write("You prepare " + menu_array[which_item][0] + " from the things " +
            "in the kitchen.\n");
      tell_room(environment(this_player()),
                MYCNAME + " prepares " +
                menu_array[which_item][0] +
                " from the things in the kitchen.\n");
   }
   return 1;
}



make_sustenance(items_data) {
   object sustenance_item;

   sustenance_item = clone_object(items_data[6]);
   sustenance_item->set_name(    items_data[0]);
   sustenance_item->set_alt_name(items_data[1]);
   sustenance_item->set_alias(   items_data[2]);
   sustenance_item->set_short(   items_data[7]);
   sustenance_item->set_long(    items_data[8]);
   sustenance_item->set_value(   items_data[3] / 2);
   sustenance_item->set_strength(items_data[4]);

   if (sizeof(items_data) >= 10) {
      /* set message displayed when drunk/eaten */
      sustenance_item->set_mess(        items_data[9]);
      sustenance_item->set_drinker_mess(items_data[9]); /* used by alco_drink */
      sustenance_item->set_eater_mess(  items_data[9]);  /* used by food */
   }
   if (sizeof(items_data) >= 11) {
      sustenance_item->set_empty_container(items_data[10]);
   }
   sustenance_item->set_weight(1);


   /* Apply the tuning definitions.  Since we can't be too sure which */
   /* source files are implementing the food/drink, use all the calls */
   /* that might be implemented.                                      */

   /* /obj/drink has a wierd way of setting this all up. */
   if (items_data[6] == "/obj/drink") {
      sustenance_item->set_value(
         items_data[0] + "#" +   /*    name         */
         items_data[7] + "#" +   /*    short_desc   */
         items_data[9] + "#" +   /*    message      */
         DRINK_HEAL_TUNE(items_data[5]) + "#" +   /*    heal         */
         (items_data[3] / 2)            + "#" +   /*    value        */
         DRINK_STR_TUNE( items_data[4]));         /*    strength     */
      sustenance_item->set_value2(
         items_data[1] + "#" +   /*    alt_name     */
         items_data[8]);         /*    long_desc    */
      return sustenance_item;
   }

   if ((items_data[6] == DRINK_FILE)         ||
       (items_data[6] == "/obj/alco_drink")  ||
       (items_data[6] == "/obj/soft_drink")  ||
       (items_data[6] == HOUSEDRINK))        {
      sustenance_item->set_heal(    DRINK_HEAL_TUNE(items_data[5]));
      sustenance_item->set_strength(DRINK_STR_TUNE( items_data[4]));
   }
   else if ((items_data[6] == FOOD_FILE) ||
            (items_data[6] == "/obj/food")) {
      sustenance_item->set_strength(FOOD_STR_TUNE(items_data[4]));
   }
   return sustenance_item;
}




