
 /* House_toolkit_obj.c      Metaprat       5th August 1992  */


#define WORKTIME     1200   /* 20 minutes */
#include "house_defines.h"
#include "array_funcs.c"

object main_hall;        /* controlling room */
int    this_room_index;  /* room that is being worked on currently */

int    working;          /* time of last activity */


/* standard functions */


get() {
   return 0;     /* can't be picked up */
}


drop() {
   if (working) {
      /* if the object is in use, then start the self-destruct sequence */
      working = 0;
      call_out("self_destruct", 1);
   }
   return 0;     /* may be dropped, but self-destructs afterwards */
}


self_destruct() {
   /* self destruct, but make sure that the weight gets decremented in */
   /* the holder, if its alive.                                        */
   working = 0;  /* mark the toolkit obj as no longer in use */
   inform_obj(environment(), capitalize(short()) + " bursts into flame.\n");
   destruct(this_object());
}


inform_obj(ob, txt) {
   if (!ob || !txt) {
      return;
   }
   if (living(ob)) {
      tell_object(ob, txt);
   }
   else {
      tell_room(ob, txt);
   }
}


query_weight() {
   return 0;     /* weightless  */
}


query_value() {
   return 0;     /* may not be sold */
}


reset(arg) {
   if (arg && environment() && !query_working()) {
      call_out("self_destruct",1);
   }
   if (arg) {
      return;
   }
   working = time();
   if (previous_object() && (previous_object()->confirm_house())) {
      main_hall = previous_object()->query_main_hall();
   }
   this_room_index = -1;
}


set_main_hall(arg) {
   main_hall = arg;
}


query_main_hall() {
   return main_hall;
}


set_room_index(arg) {
   this_room_index = arg;
}


get_room_index() {
   return this_room_index;
}


init() {
   if ((this_player())                      &&
       (MYNAME != "guest")               &&
       (main_hall && MYNAME == GETOWNER) &&
       (this_player() == environment())) {
      this_object()->toolkit_init();
   }
}


query_working() {
   /* Tries to guess if the toolkit object is still being used by the */
   /* player.  First, it checks to see that the player exists, and is */
   /* inside a house.  If these checks don't resolve the problem, it  */
   /* uses an activity timer to see if the player has made use of the */
   /* object in the previous WORKTIME seconds.                        */
   if (environment() && !environment(environment())) {
      return 0;
   }
   if (environment(environment())->confirm_house()) {
      return 1;
   }
   return time() < (working + WORKTIME);
}






