
 /* master_house.c      Metaprat       15th April 1992     */

 /* An object that stores an array of house information. */


#include "house_defines.h"
#include "array_funcs.c"

#define MASTER_HOUSE_FILE  (HOUSES_DIR + "master_house")

string        house_owners;  /* recorded */
static string table_owners;  /* not recorded */
static object table_houses;
static int    table_times;


reset(arg) {
   if (arg) {
      return;
   }
   house_owners = ({ });
   table_owners = ({ });
   table_houses = ({ });
   table_times  = ({ });
   restore_object(MASTER_HOUSE_FILE);
}


query_house(owner_name) {
   int indx;

   for (indx = sizeof(table_owners) - 1; indx >= 0; indx --) {
      if ((table_owners[indx] == owner_name) && (table_houses[indx])) {
         return table_houses[indx];
      }
   }
   return 0;
}


register_house(owner_name, house_ob) {
   table_owners = table_owners + ({ owner_name });
   table_houses = table_houses + ({ house_ob });
   table_times  = table_times +  ({ time() });
}


register_new_house(owner_name) {
   if (!search_array(house_owners, owner_name)) {
      house_owners = house_owners + ({ owner_name });
      save_object(MASTER_HOUSE_FILE);
   }
}



query_house_exists(owner_name) {
   return search_array(house_owners, owner_name);
}


master_stats() {
   string text;
   int    counter;
   int    line_cnt;

   for (counter = 0; counter < sizeof(table_owners); counter ++) {
      if (!table_houses[counter]) {
         write(table_owners[counter]            + "    \t"  +
               "**self_destructed**"            + "\t"  +
               ctime(table_times[counter])      + "\n");
      }
      else {
         write(table_owners[counter]                        + "    \t>>"  +
               extract(file_name(table_houses[counter]),16) + "\t"  +
               ctime(table_times[counter])                  + "\n");
      }
   }
   text = "List of house owners:   (" + sizeof(house_owners) + " in total)\n";
   line_cnt = 0;
   for (counter = 0; counter < sizeof(house_owners); counter ++) {
      text = text + house_owners[counter];
      line_cnt ++;
      if (line_cnt > 4) {
         write(text + "\n");
         text = "";
         line_cnt = 0;
      }
      else if (strlen(house_owners[counter]) <= 7) {
         text = text + "       \t";
      }
      else {
         text = text + "\t";
      }
   }
   if (text != "") {
      write(text + "\n");
   }
}


